using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Diagnostics;

namespace GGC_HideTable
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(16, 16);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.ShowGroupDropArea = true;
			this.gridGroupingControl1.Size = new System.Drawing.Size(616, 448);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableDescriptor.AllowNew = false;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionCurrentCellOptions = Syncfusion.Windows.Forms.Grid.Grouping.GridListBoxSelectionCurrentCellOptions.None;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.VersionInfo = "4.101.0.22";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(648, 478);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		private int numberParentRows = 20;
		

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			
			dt.Columns.Add(new DataColumn("Department",typeof(string))); //lower case p
			dt.Columns.Add(new DataColumn("SubDepartment",typeof(string)));
			dt.Columns.Add(new DataColumn("Value1",typeof(int)));
			dt.Columns.Add(new DataColumn("Value2", typeof(int)));

			
			for(int i = 0; i < numberParentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = string.Format("Dept{0}",i % 2);
				dr[1] = string.Format("SubDept{0}",i);
				dr[2] = (i+ 1) *3;
				dr[3] = (i+ 3) *5;
				dt.Rows.Add(dr);
			}
			return dt;
		}
		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable parentTable = GetParentTable();
			this.gridGroupingControl1.DataSource = parentTable;

			// Adding Summaries for the Details Table
			GridSummaryColumnDescriptor scd = new GridSummaryColumnDescriptor("Sum1",  SummaryType.Int32Aggregate, "Value1", "{Sum:#}");
			GridSummaryColumnDescriptor scd2 = new GridSummaryColumnDescriptor("Sum2",  SummaryType.Int32Aggregate, "Value2", "{Sum:#}");
			GridSummaryRowDescriptor srd = new GridSummaryRowDescriptor("Total","Total", new GridSummaryColumnDescriptor[]{scd,scd2});
			srd.Appearance.AnyCell.HorizontalAlignment = GridHorizontalAlignment.Right;
			srd.Appearance.AnyCell.BackColor = Color.FromArgb(255, 231, 162);
			this.gridGroupingControl1.TableDescriptor.SummaryRows.Add(srd);

			this.gridGroupingControl1.TableControlPrepareViewStyleInfo +=new GridTableControlPrepareViewStyleInfoEventHandler(gridGroupingControl1_TableControlPrepareViewStyleInfo);

			this.gridGroupingControl1.TableControlDrawCell +=new GridTableControlDrawCellEventHandler(gridGroupingControl1_TableControlDrawCell);

			this.gridGroupingControl1.TableDescriptor.GroupedColumns.Add("Value1");   

			

		}

		private void gridGroupingControl1_TableControlPrepareViewStyleInfo(object sender, GridTableControlPrepareViewStyleInfoEventArgs e)
		{
			GridTableCellStyleInfo style = e.Inner.Style  as GridTableCellStyleInfo; 
			if( style.TableCellIdentity.TableCellType ==  GridTableCellType.SummaryTitleCell )
			{
				Element el = style.TableCellIdentity.DisplayElement;
				if( ! el.ParentGroup.IsMainGroup  )
				{
					object category = el.ParentGroup.Category;
					if( category != null)
					{
						e.Inner.Style.Text = category + " Sub Total";  
						e.Inner.Style.HorizontalAlignment = GridHorizontalAlignment.Left;  
					}
				}
			}
		}

		private void gridGroupingControl1_TableControlDrawCell(object sender, GridTableControlDrawCellEventArgs e)
		{
			GridTableCellStyleInfo style = e.Inner.Style  as GridTableCellStyleInfo; 
			if( style.TableCellIdentity.TableCellType ==  GridTableCellType.GroupCaptionCell )
			{
				Element el = style.TableCellIdentity.DisplayElement;
				if( ! el.ParentGroup.IsMainGroup  )
				{
					object category = el.ParentGroup.Category;
					if( category != null)
					{
						e.Inner.Cancel = true; 
						Rectangle ImageRect= new Rectangle(e.Inner.Bounds.Location,new Size(20,e.Inner.Bounds.Height));
						Rectangle TextRect= new Rectangle( new Point( e.Inner.Bounds.Location.X + 20,e.Inner.Bounds.Location.Y),
							new Size(e.Inner.Bounds.Size.Width- 20,e.Inner.Bounds.Height));

						e.Inner.Renderer.Draw(e.Inner.Graphics,TextRect,e.Inner.RowIndex,e.Inner.ColIndex,e.Inner.Style);             
						e.Inner.Graphics.DrawImage(SystemIcons.Exclamation.ToBitmap(),ImageRect);          
					}
				}
			}
		}
	}
}
